## miniupnpc 2.1

=== debian/changelog ===
miniupnpc (2.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Check for PGP signature.
  * debian/watch: Only watch for release versions.

 -- Yangfl <mmyangfl@gmail.com>  Wed, 23 May 2018 01:08:20 +0800

miniupnpc (2.0.20180410-2) unstable; urgency=medium

  * Uploading to unstable.
  * Move minissdpd dep level from Recommends to Suggests (Closes: #897064).

 -- Yangfl <mmyangfl@gmail.com>  Fri, 04 May 2018 13:51:58 +0800

miniupnpc (2.0.20180410-1) experimental; urgency=medium

  [ Yangfl ]
  * New upstream release.
  * Bump Standards-Version to 4.1.4.
  * Uploading to Experimental.

  [ Thomas Goirand ]
  * Fix runtime depends of the -dev lib to version 17 of the runtime lib.

 -- Thomas Goirand <zigo@debian.org>  Sun, 22 Apr 2018 09:56:07 +0000

miniupnpc (2.0.20180222-1) unstable; urgency=medium

  [ Yangfl ]
  * New upstream release
    - Add pkg-config file (Closes: #664240)
  * Mark Breaks miniupnpc (<< 2.0) for libminiupnpc-dev (Closes: #890649)
  * Fix FTBFS on non-Linux (Closes: #891696)
  * Update VCS fields to point to Salsa

  [ Thomas Goirand ]
  * Removed man page patch.

 -- Thomas Goirand <zigo@debian.org>  Mon, 26 Mar 2018 12:42:43 +0000

miniupnpc (2.0.20171212-3) unstable; urgency=medium

  * Uploading to unstable (after ACK from the release team).

 -- Thomas Goirand <zigo@debian.org>  Mon, 12 Feb 2018 09:59:05 +0000

miniupnpc (2.0.20171212-2) experimental; urgency=medium

  [ Yangfl ]
  * New upstream release. (Closes: #804045)
  * Include help2man template. (Closes: #776642)
  * Bumped Standards-Version.
  * Switch to Python 3.

  [ Thomas Goirand ]
  * Uploading to Experimental.

 -- Thomas Goirand <zigo@debian.org>  Mon, 22 Jan 2018 12:06:07 +0100
