=== debian/changelog ===
miniupnpc (2.1.20190824-0ubuntu2) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:36:51 +0000

miniupnpc (2.1.20190824-0ubuntu1) eoan; urgency=medium

  * New upstream version

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 29 Aug 2019 10:30:06 +0200

miniupnpc (2.1.20190625-0ubuntu1) eoan; urgency=medium

  * New upstream version

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 21 Aug 2019 16:00:28 +0200

miniupnpc (2.1-1build1) disco; urgency=medium

  * No-change rebuild to build for python3.7 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Oct 2018 12:35:52 +0000
