=== debian/watch ===
version=4
opts=filenamemangle=s/.*file=([^&]*)/$1/,pgpsigurlmangle=s%$%.sig% \
	http://miniupnp.free.fr/files/download.php\?file=miniupnpc-(\d\.\d(?:-.*)?).tar.gz
