## miniupnpc 2.1.20191224

=== debian/changelog ===
miniupnpc (2.1.20191224-0ubuntu1) groovy; urgency=medium

  * New upstream version

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 28 Sep 2020 17:15:26 +0200
