=== Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
-# $Id: Makefile,v 1.140 2018/04/06 10:53:12 nanard Exp $
+# $Id: Makefile,v 1.143 2020/11/27 18:20:32 nanard Exp $
 # MiniUPnP Project
 # http://miniupnp.free.fr/
-# http://miniupnp.tuxfamily.org/
+# https://miniupnp.tuxfamily.org/
 # https://github.com/miniupnp/miniupnp
-# (c) 2005-2018 Thomas Bernard
+# (c) 2005-2020 Thomas Bernard
 # to install use :
 # $ make DESTDIR=/tmp/dummylocation install
 # or
@@ -31,6 +31,9 @@
 #AR = gar
 #CFLAGS = -O -g -DDEBUG
 CFLAGS ?= -O
+#CFLAGS = -g -ggdb -O0 -fsanitize=address -fsanitize=undefined -fsanitize=leak -fno-omit-frame-pointer
+#CFLAGS += -DDEBUG
+#LDFLAGS = -fsanitize=address -fsanitize=undefined -fsanitize=leak
 CFLAGS += -Wall
 CFLAGS += -W -Wstrict-prototypes
 CFLAGS += -fno-common
@@ -62,7 +65,7 @@
 #JNAERATORBASEURL = http://jnaerator.googlecode.com/files/
 JNAERATORBASEURL = https://repo1.maven.org/maven2/com/nativelibs4java/jnaerator/0.12
 
-ifneq (, $(findstring sun, $(OS)))
+ifneq (, $(findstring sun, $(OS))$(findstring solaris, $(OS)))
   LDLIBS=-lsocket -lnsl -lresolv
   CFLAGS += -D__EXTENSIONS__
   CFLAGS += -std=c99
@@ -77,12 +80,13 @@
        upnperrors.c testigddescparse.c testminiwget.c \
        connecthostport.c portlistingparse.c receivedata.c \
        upnpdev.c testportlistingparse.c miniupnpcmodule.c \
-       minihttptestserver.c \
+       minihttptestserver.c addr_is_reserved.c testaddr_is_reserved.c \
        listdevices.c
 
 LIBOBJS = miniwget.o minixml.o igd_desc_parse.o minisoap.o \
           miniupnpc.o upnpreplyparse.o upnpcommands.o upnperrors.o \
-          connecthostport.o portlistingparse.o receivedata.o upnpdev.o
+          connecthostport.o portlistingparse.o receivedata.o upnpdev.o \
+          addr_is_reserved.o
 
 ifeq (, $(findstring amiga, $(OS)))
 ifeq (, $(findstring mingw, $(OS))$(findstring cygwin, $(OS))$(findstring msys, $(OS)))
@@ -128,10 +132,12 @@
 
 TESTPORTLISTINGPARSE = testportlistingparse.o minixml.o portlistingparse.o
 
+TESTADDR_IS_RESERVED = testaddr_is_reserved.o addr_is_reserved.o
+
 TESTIGDDESCPARSE = testigddescparse.o igd_desc_parse.o minixml.o \
                    miniupnpc.o miniwget.o upnpcommands.o upnpreplyparse.o \
                    minisoap.o connecthostport.o receivedata.o \
-                   portlistingparse.o
+                   portlistingparse.o addr_is_reserved.o
 
 ifeq (, $(findstring amiga, $(OS)))
 EXECUTABLES := $(EXECUTABLES) upnpc-shared
@@ -167,7 +173,7 @@
 test:	check
 
 check:	validateminixml validateminiwget validateupnpreplyparse \
-	validateportlistingparse validateigddescparse
+	validateportlistingparse validateigddescparse validateaddr_is_reserved
 
 everything:	all $(EXECUTABLES_ADDTESTS)
 
@@ -209,6 +215,11 @@
 	@echo "igd desc parse validation test"
 	./testigddescparse testdesc/new_LiveBox_desc.xml testdesc/new_LiveBox_desc.values
 	./testigddescparse testdesc/linksys_WAG200G_desc.xml testdesc/linksys_WAG200G_desc.values
+	touch $@
+
+validateaddr_is_reserved:	testaddr_is_reserved
+	@echo "addr_is_reserved() validation test"
+	./testaddr_is_reserved
 	touch $@
 
 clean:
@@ -275,7 +286,7 @@
 	echo "prefix=$(INSTALLPREFIX)" >> $@
 	echo "exec_prefix=\$${prefix}" >> $@
 	echo "libdir=\$${exec_prefix}/$(LIBDIR)" >> $@
-	echo "includedir=\$${prefix}/include/miniupnpc" >> $@
+	echo "includedir=\$${prefix}/include" >> $@
 	echo "" >> $@
 	echo "Name: miniUPnPc" >> $@
 	echo "Description: UPnP IGD client lightweight library" >> $@
@@ -320,6 +331,8 @@
 testigddescparse:	$(TESTIGDDESCPARSE)
 
 testportlistingparse:	$(TESTPORTLISTINGPARSE)
+
+testaddr_is_reserved:	$(TESTADDR_IS_RESERVED)
 
 miniupnpcstrings.h:	miniupnpcstrings.h.in updateminiupnpcstrings.sh VERSION
 	$(SH) updateminiupnpcstrings.sh
@@ -368,13 +381,3 @@
 miniupnpc.o: miniupnpc.h miniupnpc_declspec.h igd_desc_parse.h upnpdev.h
 miniupnpc.o: minissdpc.h miniwget.h minisoap.h minixml.h upnpcommands.h
 miniupnpc.o: upnpreplyparse.h portlistingparse.h miniupnpctypes.h
-miniupnpc.o: connecthostport.h
-minixml.o: minixml.h
-minisoap.o: minisoap.h miniupnpcstrings.h
-miniwget.o: miniupnpcstrings.h miniwget.h miniupnpc_declspec.h
-miniwget.o: connecthostport.h receivedata.h
-upnpc.o: miniwget.h miniupnpc_declspec.h miniupnpc.h igd_desc_parse.h
-upnpc.o: upnpdev.h upnpcommands.h upnpreplyparse.h portlistingparse.h
-upnpc.o: miniupnpctypes.h upnperrors.h miniupnpcstrings.h
-upnpcommands.o: upnpcommands.h upnpreplyparse.h portlistingparse.h
-upnpcommands.o: miniupnpc_declspec.h miniupnpctypes.h miniupnpc.h
