=== debian/changelog ===
miniupnpc (2.2.1-1) unstable; urgency=medium

  * New upstream release (Closes: #935310).
  * Bump debhelper compat to 13.
  * Bump Standards-Version to 4.5.0.
  * Add upstream metadata.

 -- Yangfl <mmyangfl@gmail.com>  Mon, 04 Jan 2021 21:53:27 +0800
