=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: miniupnpc
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Goirand <zigo@debian.org>
+Maintainer: Thomas Goirand <zigo@debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 13),
  dh-python,
  python3-dev,
  python3-setuptools,
-Standards-Version: 4.1.4
+ iproute2,
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/miniupnp-team/miniupnpc
 Vcs-Git: https://salsa.debian.org/miniupnp-team/miniupnpc.git
 Homepage: http://miniupnp.free.fr/
